/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package Salary;

import Service.EmployeeReportService;
import Service.EmployeeService;
import java.awt.Font;
import java.text.MessageFormat;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;
import model.Employee;
import model.EmployeeReport;

/**
 *
 * @author AlwaysLH
 */
public class SalaryPanel extends javax.swing.JPanel {

    private final EmployeeReportService empRptService;
    private final EmployeeService empService;
    private final List<EmployeeReport> empRptList;
    DefaultTableModel model;
    DefaultTableModel toPayModel;

    /**
     * Creates new form SalaryPanel
     */
    public SalaryPanel() {
        initComponents();
        tblSalary.getTableHeader().setFont(new Font("Tahoma", Font.BOLD, 14));
        tblToPay.getTableHeader().setFont(new Font("Tahoma", Font.BOLD, 14));
        tblSalary.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblToPay.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.BOLD, 14));
        empRptService = new EmployeeReportService();
        empService = new EmployeeService();
        empRptList = empRptService.getEmployeeReports();
        model = (DefaultTableModel) tblSalary.getModel();
        toPayModel = (DefaultTableModel) tblToPay.getModel();
        for (EmployeeReport er : empRptList) {
            model.addRow(new Object[]{er.getEmpReportId(), er.getEmpId(), er.getTcReportId(), er.getTotalSalary(), er.getTotalHours(), er.getDate()});
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        tblSalary = new javax.swing.JTable();
        btnChoose = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        tblToPay = new javax.swing.JTable();
        tblRemove = new javax.swing.JButton();

        jPanel1.setBackground(new java.awt.Color(211, 197, 186));

        tblSalary.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(84, 70, 63), 2, true));
        tblSalary.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        tblSalary.setForeground(new java.awt.Color(84, 70, 63));
        tblSalary.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "รหัสรายงานพนักงาน", "รหัสพนักงาน", "รหัสรายงานเช็คเวลางาน", "เงือนเดือนรวม", "ชั่วโมงรวม", "วันที่ออกรายงาน"
            }
        ));
        tblSalary.setRowHeight(30);
        tblSalary.setSelectionBackground(new java.awt.Color(84, 70, 63));
        jScrollPane2.setViewportView(tblSalary);

        btnChoose.setBackground(new java.awt.Color(84, 70, 63));
        btnChoose.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnChoose.setForeground(new java.awt.Color(255, 255, 255));
        btnChoose.setText("Choose");
        btnChoose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnChooseActionPerformed(evt);
            }
        });

        btnSave.setBackground(new java.awt.Color(84, 70, 63));
        btnSave.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnSave.setForeground(new java.awt.Color(255, 255, 255));
        btnSave.setText("Print");
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        tblToPay.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(84, 70, 63), 2, true));
        tblToPay.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        tblToPay.setForeground(new java.awt.Color(84, 70, 63));
        tblToPay.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "รหัสพนักงาน", "ชื่อ", "นามสกุล", "ชั่วโมงรวม", "อัตรา ( บาท ) ต่อชั่วโมง", "รวม"
            }
        ));
        tblToPay.setRowHeight(40);
        tblToPay.setSelectionBackground(new java.awt.Color(84, 70, 63));
        jScrollPane3.setViewportView(tblToPay);

        tblRemove.setBackground(new java.awt.Color(84, 70, 63));
        tblRemove.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        tblRemove.setForeground(new java.awt.Color(255, 255, 255));
        tblRemove.setText("Remove");
        tblRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tblRemoveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 602, Short.MAX_VALUE)
                    .addComponent(jScrollPane2))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnChoose, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnSave, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(tblRemove, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(72, 72, 72))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
                    .addComponent(btnChoose))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(btnSave)
                        .addGap(18, 18, 18)
                        .addComponent(tblRemove))
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 286, Short.MAX_VALUE))
                .addGap(0, 0, 0))
        );

        jScrollPane1.setViewportView(jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 740, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 595, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        if (tblToPay.getRowCount() > 0) {
            MessageFormat header = new MessageFormat("รายการจ่ายเงินเดือน");
            MessageFormat footer = new MessageFormat("หน้าที่ {0, number, integer}");

            try {
                tblToPay.print(JTable.PrintMode.FIT_WIDTH, header, footer);
                toPayModel.setRowCount(0);
            } catch (java.awt.print.PrinterException e) {
                JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากไม่พบเครื่องพิมพ์", "ไม่พบเครื่องพิมพ์", JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากรายการยังว่างอยู่", "ไม่สามารถพิมพ์รายการได้", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_btnSaveActionPerformed

    private void btnChooseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnChooseActionPerformed
        int selectedRow = tblSalary.getSelectedRow();
        if (selectedRow >= 0) {
            Employee temp = empService.getEmployeeID(empRptList.get(selectedRow).getEmpId());
            toPayModel.addRow(new Object[]{temp.getEmpId(), temp.getEmpName(), temp.getEmpSurname(), empRptList.get(selectedRow).getTotalHours(), "40", empRptList.get(selectedRow).getTotalHours() * 40});
        }
    }//GEN-LAST:event_btnChooseActionPerformed

    private void tblRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tblRemoveActionPerformed
        int removeCol = tblToPay.getSelectedRow();
        if (removeCol >= 0) {
            toPayModel.removeRow(removeCol);
        }
    }//GEN-LAST:event_tblRemoveActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnChoose;
    private javax.swing.JButton btnSave;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JButton tblRemove;
    private javax.swing.JTable tblSalary;
    private javax.swing.JTable tblToPay;
    // End of variables declaration//GEN-END:variables
}
